--- kern/kern_exec.c.orig
+++ kern/kern_exec.c
@@ -188,6 +188,27 @@
 }
 
 #ifndef _SYS_SYSPROTO_H_
+struct fexecve_args {
+	int	fd;
+	char	**argv;
+	char	**envv;
+}
+#endif
+int
+fexecve(struct thread *td, struct fexecve_args *uap)
+{
+	int error;
+	struct image_args args;
+
+	error = exec_copyin_args(&args, NULL, UIO_SYSSPACE,
+	    uap->argv, uap->envv);
+	args.fd = uap->fd;
+	if (error == 0)
+		error = kern_execve(td, &args, NULL);
+	return (error);
+}
+
+#ifndef _SYS_SYSPROTO_H_
 struct __mac_execve_args {
 	char	*fname;
 	char	**argv;
@@ -293,7 +314,7 @@
 	struct vnode *tracevp = NULL;
 	struct ucred *tracecred = NULL;
 #endif
-	struct vnode *textvp = NULL;
+	struct vnode *textvp = NULL, *binvp = NULL;
 	int credential_changing;
 	int vfslocked;
 	int textset;
@@ -354,17 +375,29 @@
 	 * XXXAUDIT: It would be desirable to also audit the name of the
 	 * interpreter if this is an interpreted binary.
 	 */
-	ndp = &nd;
-	NDINIT(ndp, LOOKUP, ISOPEN | LOCKLEAF | FOLLOW | SAVENAME | MPSAFE |
-	    AUDITVNODE1, UIO_SYSSPACE, args->fname, td);
+	if (args->fname != NULL) {
+   		ndp = &nd;
+		NDINIT(ndp, LOOKUP, ISOPEN | LOCKLEAF | FOLLOW | SAVENAME 
+		    | MPSAFE | AUDITVNODE1, UIO_SYSSPACE, args->fname, td);
+	}
 
 interpret:
-	error = namei(ndp);
-	if (error)
-		goto exec_fail;
+	if (args->fname != NULL) {
+		error = namei(ndp);
+		if (error)
+			goto exec_fail;
 
-	vfslocked = NDHASGIANT(ndp);
-	imgp->vp = ndp->ni_vp;
+		vfslocked = NDHASGIANT(ndp);
+		binvp  = ndp->ni_vp;
+		imgp->vp = binvp;
+	} else {
+	   	error = fgetvp(td, args->fd, &binvp);
+		if (error)
+			goto exec_fail;
+		VOP_LOCK(binvp, LK_EXCLUSIVE, td);
+		vfslocked = VFS_NEEDSGIANT(binvp->v_mount);
+		imgp->vp = binvp;
+	}
 
 	/*
 	 * Check file permissions (also 'opens' file)
@@ -436,12 +469,13 @@
 		 */
 		imgp->vp->v_vflag &= ~VV_TEXT;
 		/* free name buffer and old vnode */
-		NDFREE(ndp, NDF_ONLY_PNBUF);
+		if (args->fname != NULL)
+   			NDFREE(ndp, NDF_ONLY_PNBUF);
 #ifdef MAC
 		interplabel = mac_vnode_label_alloc();
-		mac_copy_vnode_label(ndp->ni_vp->v_label, interplabel);
+		mac_copy_vnode_label(binvp->v_label, interplabel);
 #endif
-		vput(ndp->ni_vp);
+		vput(binvp);
 		vm_object_deallocate(imgp->object);
 		imgp->object = NULL;
 		VFS_UNLOCK_GIANT(vfslocked);
@@ -449,6 +483,7 @@
 		/* set new name to that of the interpreter */
 		NDINIT(ndp, LOOKUP, LOCKLEAF | FOLLOW | SAVENAME | MPSAFE,
 		    UIO_SYSSPACE, imgp->interpreter_name, td);
+		args->fname = imgp->interpreter_name;
 		goto interpret;
 	}
 
@@ -494,7 +529,7 @@
 	vn_lock(imgp->vp, LK_EXCLUSIVE | LK_RETRY, td);
 
 	/* Get a reference to the vnode prior to locking the proc */
-	VREF(ndp->ni_vp);
+	VREF(binvp);
 
 	/*
 	 * For security and other reasons, signal handlers cannot
@@ -520,8 +555,14 @@
 	execsigs(p);
 
 	/* name this process - nameiexec(p, ndp) */
-	len = min(ndp->ni_cnd.cn_namelen,MAXCOMLEN);
-	bcopy(ndp->ni_cnd.cn_nameptr, p->p_comm, len);
+	/* XXX: what for fexecve? */
+	if (args->fname) {
+   		len = min(ndp->ni_cnd.cn_namelen,MAXCOMLEN);
+		bcopy(ndp->ni_cnd.cn_nameptr, p->p_comm, len);
+	} else {
+	   	len = 10;
+	   	bcopy("fexec neco", p->p_comm, 10);
+	}
 	p->p_comm[len] = 0;
 
 	/*
@@ -650,7 +691,7 @@
 	 * to locking the proc lock.
 	 */
 	textvp = p->p_textvp;
-	p->p_textvp = ndp->ni_vp;
+	p->p_textvp = binvp;
 
 	/*
 	 * Notify others that we exec'd, and clear the P_INEXEC flag
@@ -733,8 +774,8 @@
 		vrele(textvp);
 		VFS_UNLOCK_GIANT(tvfslocked);
 	}
-	if (ndp->ni_vp && error != 0)
-		vrele(ndp->ni_vp);
+	if (binvp && error != 0)
+		vrele(binvp);
 #ifdef KTRACE
 	if (tracevp != NULL) {
 		int tvfslocked;
@@ -763,7 +804,8 @@
 		exec_unmap_first_page(imgp);
 
 	if (imgp->vp != NULL) {
-		NDFREE(ndp, NDF_ONLY_PNBUF);
+		if (args->fname)
+   			NDFREE(ndp, NDF_ONLY_PNBUF);
 		vput(imgp->vp);
 	}
 
@@ -981,11 +1023,14 @@
 	/*
 	 * Copy the file name.
 	 */
-	error = (segflg == UIO_SYSSPACE) ?
-	    copystr(fname, args->fname, PATH_MAX, &length) :
-	    copyinstr(fname, args->fname, PATH_MAX, &length);
-	if (error != 0)
-		goto err_exit;
+	if (fname != NULL) {
+		error = (segflg == UIO_SYSSPACE) ?
+		copystr(fname, args->fname, PATH_MAX, &length) :
+		copyinstr(fname, args->fname, PATH_MAX, &length);
+		if (error != 0)
+			goto err_exit;
+	} else
+		args->fname = NULL;
 
 	/*
 	 * extract arguments first
--- kern/syscalls.master.orig
+++ kern/syscalls.master
@@ -835,5 +835,21 @@
 474     AUE_NULL        STD    { int sctp_generic_recvmsg(int sd, struct iovec *iov, int iovlen, \
 				    struct sockaddr * from, __socklen_t *fromlenaddr, \
 				    struct sctp_sndrcvinfo *sinfo, int *msg_flags); }
+475	AUE_ACCESS	STD	{ int faccessat(int dirfd, char *path, int mode, int flag); }
+476	AUE_CHMOD	STD	{ int fchmodat(int dirfd, char *path, mode_t mode, int flag); }
+477	AUE_CHOWN	STD	{ int fchownat(int dirfd, char *path, uid_t uid, gid_t gid, int flag); }
+478	AUE_EXECVE	STD	{ int fexecve(int fd, char **argv, char **envv); }
+479	AUE_STAT	STD	{ int fstatat(int fd, char *path, struct stat *buf, int flag); }
+480	AUE_UTIMES	STD	{ int futimesat(int fd, char *path, struct timeval *times); }
+481	AUE_LINK	STD	{ int linkat(int fd1, char *path1, int fd2, char *path2, int flag); }
+482	AUE_MKDIR	STD	{ int mkdirat(int fd, char *path, mode_t mode); }
+483	AUE_MKFIFO	STD	{ int mkfifoat(int fd, char *path, mode_t mode); }
+484	AUE_MKNOD	STD	{ int mknodat(int fd, char *path, mode_t mode, dev_t dev); }
+; XXX: see the comment for open
+485	AUE_OPEN_RWTC	STD	{ int openat(int fd, char *path, int flag, mode_t mode); }
+486	AUE_READLINK	STD	{ ssize_t readlinkat(int fd, char *path, char *buf, size_t bufsize); }
+487	AUE_RENAME	STD	{ int renameat(int oldfd, char *old, int newfd, char *new); }
+488	AUE_SYMLINK	STD	{ int symlinkat(char *path1, int fd, char *path2); }
+489	AUE_UNLINK	STD	{ int unlinkat(int fd, char *path, int flag); }
 ; Please copy any additions and changes to the following compatability tables:
 ; sys/compat/freebsd32/syscalls.master
--- kern/vfs_lookup.c.orig
+++ kern/vfs_lookup.c
@@ -44,6 +44,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/fcntl.h>
 #include <sys/lock.h>
 #include <sys/mutex.h>
 #include <sys/namei.h>
@@ -192,7 +193,14 @@
 	ndp->ni_rootdir = fdp->fd_rdir;
 	ndp->ni_topdir = fdp->fd_jdir;
 
-	dp = fdp->fd_cdir;
+	if (ndp->ni_startdir)
+		dp = ndp->ni_startdir;
+	else {
+		dp = fdp->fd_cdir;
+		/* we might have raced so check it */
+		if ((cnp->cn_flags & ATBADF) && (cnp->cn_pnbuf[0] != '/'))
+			return (EBADF);
+	}
 	vfslocked = VFS_LOCK_GIANT(dp->v_mount);
 	VREF(dp);
 	FILEDESC_SUNLOCK(fdp);
@@ -1001,12 +1009,13 @@
  */
 int
 kern_alternate_path(struct thread *td, const char *prefix, char *path,
-    enum uio_seg pathseg, char **pathbuf, int create)
+    enum uio_seg pathseg, char **pathbuf, int create, int dirfd)
 {
 	struct nameidata nd, ndroot;
 	char *ptr, *buf, *cp;
 	size_t len, sz;
 	int error;
+	struct vnode *dir_vn;
 
 	buf = (char *) malloc(MAXPATHLEN, M_TEMP, M_WAITOK);
 	*pathbuf = buf;
@@ -1039,6 +1048,18 @@
 		goto keeporig;
 	}
 
+	if (dirfd == AT_FDCWD)
+		dir_vn = NULL;
+	else {
+	   	/* 
+		 * we want the original because the "prefix"
+		 * is included in the already opened dirfd
+		 */
+		bcopy(ptr, buf, len);
+		return (0);
+	}
+
+
 	/*
 	 * We know that there is a / somewhere in this pathname.
 	 * Search backwards for it, to find the file's parent dir
@@ -1051,13 +1072,13 @@
 		for (cp = &ptr[len] - 1; *cp != '/'; cp--);
 		*cp = '\0';
 
-		NDINIT(&nd, LOOKUP, FOLLOW | MPSAFE, UIO_SYSSPACE, buf, td);
+		NDINIT_AT(&nd, LOOKUP, FOLLOW | MPSAFE, UIO_SYSSPACE, buf, td, dir_vn);
 		error = namei(&nd);
 		*cp = '/';
 		if (error != 0)
 			goto keeporig;
 	} else {
-		NDINIT(&nd, LOOKUP, FOLLOW | MPSAFE, UIO_SYSSPACE, buf, td);
+		NDINIT_AT(&nd, LOOKUP, FOLLOW | MPSAFE, UIO_SYSSPACE, buf, td, dir_vn);
 
 		error = namei(&nd);
 		if (error != 0)
